<?php

namespace Drupal\drowl_header_slides\Plugin\Block;

use Drupal\Core\Block\BlockBase;

/**
 * Provides a 'DROWL Header Slides Menu Slideshow Slide Block' Block.
 *
 * @Block(
 *   id = "drowl_header_menu_slideshow_ref_block",
 *   admin_label = @Translation("DROWL Header Slides Menu Slideshow Slide Block"),
 *   category = @Translation("DROWL Header Slides"),
 * )
 */
class MenuSlideshowRefSlidesBlock extends BlockBase
{

  /**
   * {@inheritdoc}
   */
  public function build()
  {
    $menuActiveTrail = \Drupal::service('menu.active_trail');
    $menuActiveLink = $menuActiveTrail->getActiveLink();
    if (empty($menuActiveLink)) {
      return NULL;
    }
    $menuActiveLinkUuid = $menuActiveLink->getDerivativeId();
    if (empty($menuActiveLinkUuid)) {
      return NULL;
    }
    $menuActiveLinkEntity = \Drupal::service('entity.repository')
      ->loadEntityByUuid('menu_link_content', $menuActiveLinkUuid);
    if (empty($menuActiveLinkEntity)) {
      return NULL;
    }

    if (!empty($menuActiveLinkEntity) && $menuActiveLinkEntity->access('view') && $menuActiveLinkEntity->hasField('field_slideshow_ref')) {
      $mediaSlideshowEntity = $menuActiveLinkEntity->field_slideshow_ref->entity;
      if (!empty($mediaSlideshowEntity)) {
        // Return the rendered media entity:
        $build = \Drupal::entityTypeManager()->getViewBuilder('media')->view($mediaSlideshowEntity);
        return $build;
      }
    }

    return NULL;
  }

}
